#ifndef KLX_COMMON_HPP
#define KLX_COMMON_HPP

//============================================================================
// <<klx/common.hpp>>
//
//	 klxCuŋʂɎg}N^A^֐Ȃǂ
//	Œ`Ă܂B̃wb_ȊȎSẴwb_́A
//	{I"̃wb_+common.hpp"݂̂œ삷悤ɍ
//	sƍlĂ܂B
//
//============================================================================



//----------------------------------------------------------------------------
// RpCʃ}N
//----------------------------------------------------------------------------

#define KLX_COMPILER_IS_NOT_VC  1
#define KLX_COMPILER_IS_NOT_BCC 1
#define KLX_COMPILER_IS_NOT_DMC 1
#define KLX_COMPILER_IS_NOT_GCC 1

#if defined(_MSC_VER)
	#undef  KLX_COMPILER_IS_NOT_VC
	#define KLX_COMPILER_IS_VC  1
#elif defined(__BORLANDC__)
	#undef  KLX_COMPILER_IS_NOT_BCC
	#define KLX_COMPILER_IS_BCC 1
#elif defined(__DMC__)
	#undef  KLX_COMPILER_IS_NOT_DMC
	#define KLX_COMPILER_IS_DMC 1
#elif defined(__GNUC__)
	#undef  KLX_COMPILER_IS_NOT_GCC
	#define KLX_COMPILER_IS_GCC 1
#else
	#error "sorry, unsupported compiler"
#endif

//----------------------------------------------------------------------------
// ^̒`
//----------------------------------------------------------------------------

namespace klx
{
	#if KLX_COMPILER_IS_VC || KLX_COMPILER_IS_BCC
		typedef signed   __int8  sint8;
		typedef signed   __int16 sint16;
		typedef signed   __int32 sint32;
		typedef signed   __int64 sint64;
		typedef unsigned __int8  uint8;
		typedef unsigned __int16 uint16;
		typedef unsigned __int32 uint32;
		typedef unsigned __int64 uint64;
	#endif
	#if KLX_COMPILER_IS_DMC || KLX_COMPILER_IS_GCC
		typedef signed char        sint8;
		typedef signed short       sint16;
		typedef signed int         sint32;
		typedef signed long long   sint64;
		typedef unsigned char      uint8;
		typedef unsigned short     uint16;
		typedef unsigned int       uint32;
		typedef unsigned long long uint64;
	#endif

	typedef unsigned char    uchar;
	typedef unsigned short   ushort;
	typedef unsigned int     uint;
	typedef unsigned long    ulong;
}

//----------------------------------------------------------------------------
// ȒPȃvvZbT⏕
//----------------------------------------------------------------------------

	// g[N
	#define KLX_PP_CAT(a, b) KLX_PP_CAT_IMPL(a, b)
	#  define KLX_PP_CAT_IMPL(a, b) a##b

	// 
	#define KLX_PP_STR(a) KLX_PP_STR_IMPL(a)
	#  define KLX_PP_STR_IMPL(a) #a

	// xӂۂO𐶐
	#define KLX_ANON_ID(basename) KLX_PP_CAT(basename, __LINE__)

//----------------------------------------------------------------------------
// ȒPȃev[g^vO~O⏕
//----------------------------------------------------------------------------

namespace klx
{
	// TCYisizeof̌ʁjw肵^
	template<int N> struct sized_type { typedef char (&type)[N]; };
	typedef sized_type<1>::type yes_type;
	typedef sized_type<2>::type  no_type;

	// Cӂ̌^̃IuWFNg󂯂^B(...) ̑ (other_type) B
	struct sink_type { template<typename T> sink_type(const T&); };
	typedef sink_type other_type;
}



#endif // INCLUDE_GUARD
